#! /usr/bin/perl -w

use strict;
use IO qw(Socket File Pipe);
use Fcntl qw(F_SETFL F_GETFD FD_CLOEXEC);
use POSIX;

my $address = shift
  or die("Usage $0 NTP-address");

my $p = IO::Socket::INET->new( Proto => 'udp',
                               LocalPort => 'ntp',
                               ReuseAddr => 1);
my $paddr =gethostbyname($address)
  or die("Cannot bind address of NTP server ($address).");

system(qw(killall -q /usr/libexec/ntpwatchd)); # just in case

$SIG{CHLD} = sub {
    die("Sub process has ended");
    exit(1);
};


POSIX::nice(-20);
if(fork()==0) {
    POSIX::dup2($p->fileno(),10);
    $p=undef;

    my $f = "/var/run/ntpwatchd.pid";
    die("$f already exists, kill other server first") if -f $f;
    IO::File->new($f,"w")->print("$$\n");

    my $DN="/tmp/debug-devnull";
    $DN="/dev/null" unless $ENV{DEBUG_NTP};
    open(STDIN,  "<", "/dev/null");
    open(STDOUT, ">", $DN);
    open(STDERR, ">", $DN);
    POSIX::setsid();
    %ENV=();
    exec("/usr/libexec/ntpwatchd") or
    exec("/bin/false");
}
# Allow crashing if it wants to crash
select(undef,undef,undef,0.3);
$p = IO::Socket::INET->new( Proto => 'udp',
                            LocalAddr => '127.0.0.1:25',
                            ReuseAddr => 1,
                            PeerAddr  => '127.0.0.1:ntp');
$p->print("\xFF\0\0\1$paddr");
exit(0);


